// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DBFFile.pas' rev: 6.00

#ifndef DBFFileHPP
#define DBFFileHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dbffile
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct RFileHeader
{
	Byte DBType;
	Byte Year;
	Byte Month;
	Byte Day;
	int RecCount;
	Word HeaderSize;
	int RecordSize;
	Byte FDelayTrans;
	Byte Reserve2[13];
	Byte FlagMDX;
	Byte Reserve3[3];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct RMemoHeader
{
	unsigned NextBlock;
	unsigned BlockSize;
	Byte Reserve[504];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct RFPTMemoHeader
{
	unsigned NextBlock;
	Word Unused;
	Word BlockSize;
	Byte Reserve[504];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct RFPTMemoBlockHeader
{
	unsigned BlockSignature;
	unsigned MemoLength;
} ;
#pragma pack(pop)

typedef char TFieldName[10];

#pragma pack(push, 1)
struct RDescriptor
{
	char FieldName[10];
	char FieldEnd;
	char FieldType;
	int FieldDisp;
	Byte FieldLen;
	Byte FieldDec;
	Byte A1[13];
	Byte FlagTagMDX;
} ;
#pragma pack(pop)

class DELPHICLASS TDescriptor;
class PASCALIMPLEMENTATION TDescriptor : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	char FieldName[10];
	char FieldType;
	int FieldDisp;
	Byte FieldLen;
	Byte FieldDec;
	Byte FlagTagMDX;
	
public:
	__fastcall TDescriptor(const RDescriptor &DRec);
	void __fastcall GetData(RDescriptor &DRec);
	AnsiString __fastcall GetName();
	char __fastcall GetType(void);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TDescriptor(void) { }
	#pragma option pop
	
};


class DELPHICLASS TBaseElem;
class PASCALIMPLEMENTATION TBaseElem : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	System::SmallString<12>  ElName;
	char ElType;
	int ElLen;
	int ElDec;
	
public:
	__fastcall TBaseElem(const AnsiString AName, char AType, int ALen, int ADec);
	__fastcall virtual ~TBaseElem(void);
};


class DELPHICLASS TBaseList;
class PASCALIMPLEMENTATION TBaseList : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	bool InitF;
	int cbResult;
	Classes::TList* List;
	TBaseElem* __fastcall GetElem(int Index);
	int __fastcall GetCount(void);
	
public:
	__fastcall TBaseList(void);
	__fastcall virtual ~TBaseList(void);
	void __fastcall Add(TBaseElem* ABaseElem);
	__property int Count = {read=GetCount, nodefault};
	__property TBaseElem* Elems[int Index] = {read=GetElem};
};


#pragma option push -b-
enum TMemoType { mtNone, mtDBT, mtFPT };
#pragma option pop

class DELPHICLASS TDBFRead;
class PASCALIMPLEMENTATION TDBFRead : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Byte FlagInit;
	AnsiString DBFName;
	int Res;
	Classes::TFileStream* MemoFile;
	#pragma pack(push, 1)
	RMemoHeader MemoHeader;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	RFPTMemoHeader FPTMemoHeader;
	#pragma pack(pop)
	
	int DBFHandle;
	#pragma pack(push, 1)
	RFileHeader DBFHeader;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	RDescriptor Descriptor;
	#pragma pack(pop)
	
	Classes::TList* DList;
	int FRecNo;
	bool FDeleted;
	TMemoType FMemoType;
	AnsiString __fastcall GetMemoData(int BlockNo);
	int __fastcall StrBuffToNum(const AnsiString ABuff);
	
protected:
	Byte __fastcall GetVersion(void);
	int __fastcall GetRCount(void);
	int __fastcall GetFCount(void);
	bool __fastcall GetEof(void);
	AnsiString __fastcall GetFieldName(int Index);
	char __fastcall GetFieldType(int Index);
	int __fastcall GetFieldLength(int Index);
	int __fastcall GetFieldDec(int Index);
	int __fastcall GetFieldDisp(int Index);
	
public:
	__fastcall TDBFRead(const AnsiString DBName);
	__fastcall virtual ~TDBFRead(void);
	virtual void __fastcall ErrorHandle(int Error);
	int __fastcall GetNumField(const AnsiString Name);
	char __fastcall GetType(const AnsiString Name);
	int __fastcall GetLength(const AnsiString Name);
	int __fastcall GetDecName(const AnsiString Name);
	int __fastcall GetDisp(const AnsiString Name);
	AnsiString __fastcall GetData(int FieldNum);
	__property Byte Version = {read=GetVersion, nodefault};
	__property int RecordCount = {read=GetRCount, nodefault};
	__property int FieldCount = {read=GetFCount, nodefault};
	__property int RecNo = {read=FRecNo, nodefault};
	__property bool Deleted = {read=FDeleted, nodefault};
	__property bool Eof = {read=GetEof, nodefault};
	__property AnsiString FileName = {read=DBFName};
	__property AnsiString FieldName[int Index] = {read=GetFieldName};
	__property char FieldType[int Index] = {read=GetFieldType};
	__property int FieldLength[int Index] = {read=GetFieldLength};
	__property int FieldDec[int Index] = {read=GetFieldDec};
	__property int FieldDisp[int Index] = {read=GetFieldDisp};
	__property TMemoType MemoType = {read=FMemoType, write=FMemoType, nodefault};
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint dBaseIII = 0x3;
static const Byte dBaseIIIMemo = 0x83;
static const Byte dBaseIVMemo = 0x8b;
static const Shortint dBaseIVSQL = 0x63;
static const Shortint FoxPro = 0x5;
static const Byte FoxProMemo = 0xf5;
static const Shortint VisualFoxPro = 0x30;
static const char dftString = '\x43';
static const char dftBoolean = '\x4c';
static const char dftNumber = '\x4e';
static const char dftMemo = '\x4d';
static const char dftFloat = '\x46';
static const char dftDate = '\x44';
static const Shortint dbfFileEmpty = 0x64;
static const Shortint dbfENoFileName = 0x65;
static const Shortint dbfEFileNotFound = 0x66;
static const Shortint dbfECreate = 0x67;
static const Shortint dbfEOpen = 0x68;
static const Shortint dbfESeek = 0x69;
static const Shortint dbfERead = 0x6a;
static const Shortint dbfEWrite = 0x6b;
static const Shortint dbfEOutOfMemory = 0x6c;
static const Shortint dbfEDestruct = 0x6d;
static const Shortint dbfECreateList = 0x6e;
static const Shortint dbfEOutOfNumber = 0x6f;
static const Byte crEFileNotFound = 0xc8;
static const Byte crEOutOfMemory = 0xc9;
static const Shortint erInvalidHandle = 0x6;
static const Shortint erSharedViolation = 0x20;
static const Shortint erLockingViolation = 0x21;
static const Shortint erSharingBufferOverflov = 0x24;
extern PACKAGE AnsiString __fastcall DBFTypeToStr(char DBFType);

}	/* namespace Dbffile */
using namespace Dbffile;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DBFFile
